
import net.sf.saxon.Configuration;
import net.sf.saxon.Version;
import net.sf.saxon.FeatureKeys;
import net.sf.saxon.event.Sender;
import com.saxonica.validate.Sink;
import com.saxonica.validate.SchemaAwareConfiguration;
import com.saxonica.importer.SchemaReader;
import net.sf.saxon.om.NamePool;
import com.saxonica.schema.Schema;
import com.saxonica.SchemaAwareTransformerFactory;
import net.sf.saxon.type.SchemaException;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;
import org.apache.xerces.xni.grammars.XMLGrammarDescription;
import org.apache.xerces.xni.grammars.Grammar;
import org.apache.xerces.xni.parser.XMLInputSource;
import org.apache.xerces.xni.parser.XMLErrorHandler;
import org.apache.xerces.xni.parser.XMLParseException;
import org.apache.xerces.xni.XNIException;
import org.apache.xerces.util.XMLGrammarPoolImpl;
import org.apache.xerces.util.SymbolTable;
import org.apache.xerces.parsers.XMLGrammarPreparser;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.transform.*;
import javax.xml.transform.sax.SAXResult;
import javax.xml.transform.stream.StreamSource;
import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.FileWriter;
import java.net.URI;

/**
 * This class performs schema validation of a source document against the
 * schema specified in its xsi:schemaLocation attribute
 */

public class QuickValidator {

    public static void main(String[] args) throws Exception {
        if (args.length < 1) {
            System.err.println("No source file supplied");
        }
        try {
            System.setProperty("javax.xml.transform.TransformerFactory",
                               "com.saxonica.SchemaAwareTransformerFactory");
            TransformerFactory factory = TransformerFactory.newInstance();
            factory.setAttribute(FeatureKeys.SCHEMA_VALIDATION, Boolean.TRUE);
            if (args.length > 1) {
                StreamSource schema = new StreamSource(new File(args[1]).toURI().toString());
                ((SchemaAwareTransformerFactory)factory).addSchema(schema);
            }
            Transformer trans = factory.newTransformer();
            StreamSource source = new StreamSource(new File(args[0]).toURI().toString());
            SAXResult sink = new SAXResult(new DefaultHandler());
            trans.transform(source, sink);
        } catch (TransformerException err) {
            System.err.println("Validation failed");
        }
    }

}
